package battleship;

import java.util.Random;

public class Ocean {

    // instance variables
    private Ship[][] ships;
    private int shotsFired;
    private int hitCount;
    private int shipsSunk;

    public static int[][] tracker;
    public static int[][] trackerTemp;
    public static String shipTypeTemp;

    // constructor
    public Ocean() {
        ships = new Ship[10][10];
        tracker = new int[10][10];
        trackerTemp = new int[10][10];
        for (int x = 0; x < 10; x++) {
            for (int y = 0; y < 10; y++) {
                tracker[x][y] = -1;
                trackerTemp[x][y] = -1;
            }
        }
        shipTypeTemp = "";
        shotsFired = 0;
        hitCount = 0;
        shipsSunk = 0;
    }

    // select random positions for the ships
    //Place all ten ships randomly on the (initially empty) ocean. Place larger
    //ships before smaller ones, or you may end up with no legal place to put a
    //large ship. You will want to use the Random class in
    public void placeAllShipsRandomly() {
        Random rand = new Random();
        int numberOfShipsPlaced = 0;
        Ship shp = new Ship();

        //first do the battleShip length of 4
        int x = 0;
        int y = 0;
        while (true) {
            x = rand.nextInt(10);
            y = rand.nextInt(10);
            shipTypeTemp = "BattleShip";
            for (int i = 0; i < 10; i++) {
                for (int j = 0; j < 10; j++) {
                    trackerTemp[i][j] = tracker[i][j];
                }
            }
            boolean vCheck = shp.okToPlaceShipAt(x, y, false, this); //horizontal is false
            if (vCheck) {
                for (int i = 0; i < 10; i++) {
                    for (int j = 0; j < 10; j++) {
                        tracker[i][j] = trackerTemp[i][j];
                    }
                }
                shp.placeShipAt(x, y, false, this);
                numberOfShipsPlaced++;
                break;
            }
            for (int i = 0; i < 10; i++) {
                for (int j = 0; j < 10; j++) {
                    trackerTemp[i][j] = tracker[i][j];
                }
            }
            boolean hCheck = shp.okToPlaceShipAt(x, y, true, this); //horizontal is true
            if (hCheck) {
                for (int i = 0; i < 10; i++) {
                    for (int j = 0; j < 10; j++) {
                        tracker[i][j] = trackerTemp[i][j];
                    }
                }
                shp.placeShipAt(x, y, true, this);
                numberOfShipsPlaced++;
                break;
            }
            if (numberOfShipsPlaced == 1) {
                break;
            }
        }

        //next 2 cruisers
        int k = 0;
        while (k < 2) {
            while (true) {
                x = rand.nextInt(10);
                y = rand.nextInt(10);
                shipTypeTemp = "Cruiser";
                for (int i = 0; i < 10; i++) {
                    for (int j = 0; j < 10; j++) {
                        trackerTemp[i][j] = tracker[i][j];
                    }
                }
                boolean vCheck = shp.okToPlaceShipAt(x, y, false, this); //horizontal is false
                if (vCheck) {
                    for (int i = 0; i < 10; i++) {
                        for (int j = 0; j < 10; j++) {
                            tracker[i][j] = trackerTemp[i][j];
                        }
                    }
                    shp.placeShipAt(x, y, false, this);
                    numberOfShipsPlaced++;
                    break;
                }
                for (int i = 0; i < 10; i++) {
                    for (int j = 0; j < 10; j++) {
                        trackerTemp[i][j] = tracker[i][j];
                    }
                }
                boolean hCheck = shp.okToPlaceShipAt(x, y, true, this); //horizontal is true
                if (hCheck) {
                    for (int i = 0; i < 10; i++) {
                        for (int j = 0; j < 10; j++) {
                            tracker[i][j] = trackerTemp[i][j];
                        }
                    }
                    shp.placeShipAt(x, y, true, this);
                    numberOfShipsPlaced++;
                    break;
                }
            }
            k++;
        }

        //next 3 destroyers
        k = 0;
        while (k < 3) {
            while (true) {
                x = rand.nextInt(10);
                y = rand.nextInt(10);
                shipTypeTemp = "Destroyer";
                for (int i = 0; i < 10; i++) {
                    for (int j = 0; j < 10; j++) {
                        trackerTemp[i][j] = tracker[i][j];
                    }
                }
                boolean vCheck = shp.okToPlaceShipAt(x, y, false, this); //horizontal is false
                if (vCheck) {
                    for (int i = 0; i < 10; i++) {
                        for (int j = 0; j < 10; j++) {
                            tracker[i][j] = trackerTemp[i][j];
                        }
                    }
                    shp.placeShipAt(x, y, false, this);
                    numberOfShipsPlaced++;
                    break;
                }
                for (int i = 0; i < 10; i++) {
                    for (int j = 0; j < 10; j++) {
                        trackerTemp[i][j] = tracker[i][j];
                    }
                }
                boolean hCheck = shp.okToPlaceShipAt(x, y, true, this); //horizontal is true
                if (hCheck) {
                    for (int i = 0; i < 10; i++) {
                        for (int j = 0; j < 10; j++) {
                            tracker[i][j] = trackerTemp[i][j];
                        }
                    }
                    shp.placeShipAt(x, y, true, this);
                    numberOfShipsPlaced++;
                    break;
                }
            }
            k++;
        }

        //next 4 submarines -- make them all horizontal
        k = 0;
        while (k < 4) {
            while (true) {
                x = rand.nextInt(10);
                y = rand.nextInt(10);
                shipTypeTemp = "Submarine";
                for (int i = 0; i < 10; i++) {
                    for (int j = 0; j < 10; j++) {
                        trackerTemp[i][j] = tracker[i][j];
                    }
                }
                boolean vCheck = shp.okToPlaceShipAt(x, y, true, this); //horizontal is false
                if (vCheck) {
                    for (int i = 0; i < 10; i++) {
                        for (int j = 0; j < 10; j++) {
                            tracker[i][j] = trackerTemp[i][j];
                        }
                    }
                    shp.placeShipAt(x, y, true, this);
                    numberOfShipsPlaced++;
                    break;
                }
            }
            k++;
        }
        if (numberOfShipsPlaced != 10) {
            System.out.println("Error in the number of ships placed!");
        }
        //make empty ocean objects for the null ships elements. null tracker and use it to keep track of shooting during the game.
        for (int i = 0; i < 10; i++) {
            for (int j = 0; j < 10; j++) {
                if (ships[i][j] == null) {
                    ships[i][j] = new EmptySea();
                }
                trackerTemp[i][j] = 0;
            }
        }
    }

    public boolean isOccupied(int row, int column) {
        return (!ships[row][column].getShipType().equals("empty"));
    }

//o Returns true if the given location contains a ”real” ship, still afloat, (not
//an EmptySea), false if it does not. In addition, this method updates the
// of shots that have been fired, and the number of hits.
//o Note: If a location contains a “real” ship, shootAt should return true
//every time the user shoots at that same location. Once a ship has been
//”sunk”, additional shots at its location should return false.
//
    public boolean shootAt(int row, int column) {
        trackerTemp[row][column]++;
        boolean ret = true;

        if (!isOccupied(row, column)) {
            ret = false;
            shotsFired++;
            System.out.println("miss");
        } else {
            if (ships[row][column].shootAt(row, column)) {
                shotsFired++;
                hitCount++;
                System.out.println("hit");
            }
        }
        if (ships[row][column].isSunk()) {
            shipsSunk++;
            System.out.println("You just sank a ship - " + ships[row][column].getShipType());
            if (shipsSunk == 10) {
                System.out.println("The game is over -- all ships were sunk with " + shotsFired + " shots fired.");
            }
            ret = false;
        }
        return ret;
    }

    public int getShotsFired() {
        return shotsFired;
    }

    public int getHitCount() {
        return hitCount;
    }

    public int getShipsSunk() {
        return shipsSunk;
    }

    public boolean isGameOver() {
        return (shipsSunk == 10);
    }

    public Ship[][] getShipArray() {
        return ships;
    }

    public void print() {
        ///////////////////////////////////////////////
        //for testing only
        for (int i = 0; i < 10; i++) {
            for (int j = 0; j < 10; j++) {
                if (tracker[i][j] == -1 || tracker[i][j] == -2) {
                    System.out.print("0");
                } else {
                    System.out.print(tracker[i][j]);
                }
            }
            System.out.println("");
        }
        //System.out.println("");
        ///////////////////////////////////////////////////////////////////////////////////////////////////////
        System.out.println("  0 1 2 3 4 5 6 7 8 9");
        for (int i = 0; i < 10; i++) {
            System.out.print(i + " ");
            for (int j = 0; j < 10; j++) {
                if (trackerTemp[i][j] > 0) {
                    System.out.print(ships[i][j].toString() + " ");
                } else {
                    System.out.print("." + " ");
                }
            }
            System.out.println("");
        }

    }
}
