package battleship;

public class Ship {

    private int bowRow;
    private int bowColumn;
    private int length;
    private boolean horizontal;
    private String shipType;

    // each ship will have own hit array so needs to be customized
    private boolean[] hit;

    public Ship() {
        shipType = "";
        bowRow = -1;
        bowColumn = -1;
        length = -1;
        horizontal = false;
    }

    public int getBowRow() {
        return bowRow;
    }

    public void setBowRow(int bowRow) {
        this.bowRow = bowRow;
    }

    public int getBowColumn() {
        return bowColumn;
    }

    public void setBowColumn(int bowColumn) {
        this.bowColumn = bowColumn;
    }

    public boolean[] getHit() {
        return hit;
    }

    public boolean isHorizontal() {
        return horizontal;
    }

    public void setHorizontal(boolean horizontal) {
        this.horizontal = horizontal;
    }

    public String getShipType() {
        return shipType;
    }

    public boolean okToPlaceShipAt(int row, int column, boolean horizontal, Ocean ocean) {
        boolean vCheck = true;
        boolean hCheck = true;
        ///////////////////////////////////////////////////////////////////////////////////////////////////////
        //battleShip
        if (Ocean.shipTypeTemp.equals("BattleShip")) {
            if (!horizontal) {
                //check if the ship fits vertically
                if (row + 3 >= 10) { //pick 5 e.g, the use 5, 6, 7, 8
                    vCheck = false;
                    return false;
                } else {
                    for (int i = 0; i < 4; i++) {
                        if (Ocean.trackerTemp[row + i][column] == -1) {
                            Ocean.trackerTemp[row + i][column] = 3;
                        }
                    }
                }

                //surround the boat with -2's where possible
                if (column - 1 >= 0) {
                    for (int i = 0; i < 4; i++) {
                        if (Ocean.trackerTemp[row + i][column - 1] == -1) {
                            Ocean.trackerTemp[row + i][column - 1] = -2;
                        } else {
                            vCheck = false;
                            return false;
                        }
                    }
                }

                if (column + 1 < 10) {
                    for (int i = 0; i < 4; i++) {
                        if (Ocean.trackerTemp[row + i][column + 1] == -1) {
                            Ocean.trackerTemp[row + i][column + 1] = -2;
                        } else {
                            vCheck = false;
                            return false;
                        }
                    }
                }

                if (row - 1 >= 0) {
                    if (Ocean.trackerTemp[row - 1][column] == -1) {
                        Ocean.trackerTemp[row - 1][column] = -2;
                    } else {
                        vCheck = false;
                        return false;
                    }
                }

                if (row + 4 < 10) {
                    if (Ocean.trackerTemp[row + 4][column] == -1) {
                        Ocean.trackerTemp[row + 4][column] = -2;
                    } else {
                        vCheck = false;
                        return false;
                    }
                }

                if (vCheck == false) {
                    return false;
                } else {
                    return true;
                }
            } //end of vetical test
            //
            else {//check if the ship fits horizontally
                if (column + 3 >= 10) {
                    hCheck = false;
                    return false;
                } else {
                    for (int i = 0; i < 4; i++) {
                        if (Ocean.trackerTemp[row][column + i] == -1) {
                            Ocean.trackerTemp[row][column + i] = 3;
                        }
                    }
                }

                //surround the boat with -2's where possible
                if (row - 1 >= 0) {
                    for (int i = 0; i < 4; i++) {
                        if (Ocean.trackerTemp[row - 1][column + i] == -1) {
                            Ocean.trackerTemp[row - 1][column + i] = -2;
                        } else {
                            hCheck = false;
                            return false;
                        }
                    }
                }

                if (row + 1 < 10) {
                    for (int i = 0; i < 4; i++) {
                        if (Ocean.trackerTemp[row + 1][column + i] == -1) {
                            Ocean.trackerTemp[row + 1][column + i] = -2;
                        } else {
                            hCheck = false;
                            return false;
                        }
                    }
                }

                if (column - 1 >= 0) {
                    if (Ocean.trackerTemp[row][column - 1] == -1) {
                        Ocean.trackerTemp[row][column - 1] = -2;
                    } else {
                        hCheck = false;
                        return false;
                    }
                }

                if (column + 4 < 10) {
                    if (Ocean.trackerTemp[row][column + 4] == -1) {
                        Ocean.trackerTemp[row][column + 4] = -2;
                    } else {
                        hCheck = false;
                        return false;
                    }
                }

                if (hCheck == false) {
                    return false;
                } else {
                    return true;
                }
            }
        }//end battleship
        ///////////////////////////////////////////////////////////////////////////////////////////////////////
//Cruiser
        if (Ocean.shipTypeTemp.equals("Cruiser")) {
            if (!horizontal) {
                //check if the ship fits horizontally or vert

                if (row + 2 >= 10) { //pick 5 e.g, the use 5, 6, 7, 8
                    vCheck = false;
                    return false;
                } else {
                    for (int i = 0; i < 3; i++) {
                        if (Ocean.trackerTemp[row + i][column] == -1) {
                            Ocean.trackerTemp[row + i][column] = 3;
                        }
                    }
                }

                //surround the boat with -2's where possible
                if (column - 1 >= 0) {
                    for (int i = 0; i < 3; i++) {
                        if (Ocean.trackerTemp[row + i][column - 1] == -1) {
                            Ocean.trackerTemp[row + i][column - 1] = -2;
                        } else {
                            vCheck = false;
                            return false;
                        }
                    }
                }

                if (column + 1 < 10) {
                    for (int i = 0; i < 3; i++) {
                        if (Ocean.trackerTemp[row + i][column + 1] == -1) {
                            Ocean.trackerTemp[row + i][column + 1] = -2;
                        } else {
                            vCheck = false;
                            return false;
                        }
                    }
                }

                if (row - 1 >= 0) {
                    if (Ocean.trackerTemp[row - 1][column] == -1) {
                        Ocean.trackerTemp[row - 1][column] = -2;
                    } else {
                        vCheck = false;
                        return false;
                    }
                }

                if (row + 3 < 10) {
                    if (Ocean.trackerTemp[row + 3][column] == -1) {
                        Ocean.trackerTemp[row + 3][column] = -2;
                    } else {
                        vCheck = false;
                        return false;
                    }
                }

                if (vCheck == false) {
                    return false;
                } else {
                    return true;
                }
            } else {
                //check if the ship fits horizontally or vert

                if (column + 2 >= 10) {
                    hCheck = false;
                    return false;
                } else {
                    for (int i = 0; i < 3; i++) {
                        if (Ocean.trackerTemp[row][column + i] == -1) {
                            Ocean.trackerTemp[row][column + i] = 3;
                        }
                    }
                }

                //surround the boat with -2's where possible
                if (row - 1 >= 0) {
                    for (int i = 0; i < 3; i++) {
                        if (Ocean.trackerTemp[row - 1][column + i] == -1) {
                            Ocean.trackerTemp[row - 1][column + i] = -2;
                        } else {
                            hCheck = false;
                            return false;
                        }
                    }
                }

                if (row + 1 < 10) {
                    for (int i = 0; i < 3; i++) {
                        if (Ocean.trackerTemp[row + 1][column + i] == -1) {
                            Ocean.trackerTemp[row + 1][column + i] = -2;
                        } else {
                            hCheck = false;
                            return false;
                        }
                    }
                }

                if (column - 1 >= 0) {
                    if (Ocean.trackerTemp[row][column - 1] == -1) {
                        Ocean.trackerTemp[row][column - 1] = -2;
                    } else {
                        hCheck = false;
                        return false;
                    }
                }

                if (column + 3 < 10) {
                    if (Ocean.trackerTemp[row][column + 3] == -1) {
                        Ocean.trackerTemp[row][column + 3] = -2;
                    } else {
                        hCheck = false;
                        return false;
                    }
                }

                if (hCheck == false) {
                    return false;
                } else {
                    return true;
                }
            }

        }//end cruiser
///////////////////////////////////////////////////////////////////////////////////////////////////////////
        //Destroyer

        if (Ocean.shipTypeTemp.equals("Destroyer")) {
            if (!horizontal) {
                //check if the ship fits horizontally or vert

                if (row + 1 >= 10) { //pick 5 e.g, the use 5, 6, 7, 8
                    vCheck = false;
                    return false;
                } else {
                    for (int i = 0; i < 2; i++) {
                        if (Ocean.trackerTemp[row + i][column] == -1) {
                            Ocean.trackerTemp[row + i][column] = 3;
                        }
                    }
                }

                //surround the boat with -2's where possible
                if (column - 1 >= 0) {
                    for (int i = 0; i < 2; i++) {
                        if (Ocean.trackerTemp[row + i][column - 1] == -1) {
                            Ocean.trackerTemp[row + i][column - 1] = -2;
                        } else {
                            vCheck = false;
                            return false;
                        }
                    }
                }

                if (column + 1 < 10) {
                    for (int i = 0; i < 2; i++) {
                        if (Ocean.trackerTemp[row + i][column + 1] == -1) {
                            Ocean.trackerTemp[row + i][column + 1] = -2;
                        } else {
                            vCheck = false;
                            return false;
                        }
                    }
                }

                if (row - 1 >= 0) {
                    if (Ocean.trackerTemp[row - 1][column] == -1) {
                        Ocean.trackerTemp[row - 1][column] = -2;
                    } else {
                        vCheck = false;
                        return false;
                    }
                }

                if (row + 2 < 10) {
                    if (Ocean.trackerTemp[row + 2][column] == -1) {
                        Ocean.trackerTemp[row + 2][column] = -2;
                    } else {
                        vCheck = false;
                        return false;
                    }
                }

                if (vCheck == false) {
                    return false;
                } else {
                    return true;
                }
            } else {
                //check if the ship fits horizontally or vert

                if (column + 1 >= 10) {
                    hCheck = false;
                    return false;
                } else {
                    for (int i = 0; i < 2; i++) {
                        if (Ocean.trackerTemp[row][column + i] == -1) {
                            Ocean.trackerTemp[row][column + i] = 3;
                        }
                    }
                }

                //surround the boat with -2's where possible
                if (row - 1 >= 0) {
                    for (int i = 0; i < 2; i++) {
                        if (Ocean.trackerTemp[row - 1][column + i] == -1) {
                            Ocean.trackerTemp[row - 1][column + i] = -2;
                        } else {
                            hCheck = false;
                            return false;
                        }
                    }
                }

                if (row + 1 < 10) {
                    for (int i = 0; i < 2; i++) {
                        if (Ocean.trackerTemp[row + 1][column + i] == -1) {
                            Ocean.trackerTemp[row + 1][column + i] = -2;
                        } else {
                            hCheck = false;
                            return false;
                        }
                    }
                }

                if (column - 1 >= 0) {
                    if (Ocean.trackerTemp[row][column - 1] == -1) {
                        Ocean.trackerTemp[row][column - 1] = -2;
                    } else {
                        hCheck = false;
                        return false;
                    }
                }

                if (column + 2 < 10) {
                    if (Ocean.trackerTemp[row][column + 2] == -1) {
                        Ocean.trackerTemp[row][column + 2] = -2;
                    } else {
                        hCheck = false;
                        return false;
                    }
                }

                if (hCheck == false) {
                    return false;
                } else {
                    return true;
                }
            }
        }//end destroyer
///////////////////////////////////////////////////////////////////////////////////////////////////////////
        //Submarine

        if (Ocean.shipTypeTemp.equals("Submarine")) {
            if (!horizontal) {
                //check if the ship fits horizontally or vert
                if (row + 0 >= 10) { //pick 5 e.g, the use 5, 6, 7, 8
                    vCheck = false;
                    return false;
                } else {
                    for (int i = 0; i < 1; i++) {
                        if (Ocean.trackerTemp[row + i][column] == -1) {
                            Ocean.trackerTemp[row + i][column] = 3;
                        }
                    }
                }

                //surround the boat with -2's where possible
                if (column - 1 >= 0) {
                    for (int i = 0; i < 1; i++) {
                        if (Ocean.trackerTemp[row + i][column - 1] == -1) {
                            Ocean.trackerTemp[row + i][column - 1] = -2;
                        } else {
                            vCheck = false;
                            return false;
                        }
                    }
                }

                if (column + 1 < 10) {
                    for (int i = 0; i < 1; i++) {
                        if (Ocean.trackerTemp[row + i][column + 1] == -1) {
                            Ocean.trackerTemp[row + i][column + 1] = -2;
                        } else {
                            vCheck = false;
                            return false;
                        }
                    }
                }

                if (row - 1 >= 0) {
                    if (Ocean.trackerTemp[row - 1][column] == -1) {
                        Ocean.trackerTemp[row - 1][column] = -2;
                    } else {
                        vCheck = false;
                        return false;
                    }
                }

                if (row + 1 < 10) {
                    if (Ocean.trackerTemp[row + 1][column] == -1) {
                        Ocean.trackerTemp[row + 1][column] = -2;
                    } else {
                        vCheck = false;
                        return false;
                    }
                }

                if (vCheck == false) {
                    return false;
                } else {
                    return true;
                }
            } else {
                //check if the ship fits horizontally or vert
                if (column + 0 >= 10) {
                    hCheck = false;
                    return false;
                } else {
                    for (int i = 0; i < 1; i++) {
                        if (Ocean.trackerTemp[row][column + i] == -1) {
                            Ocean.trackerTemp[row][column + i] = 3;
                        }
                    }
                }

                //surround the boat with -2's where possible
                if (row - 1 >= 0) {
                    for (int i = 0; i < 1; i++) {
                        if (Ocean.trackerTemp[row - 1][column + i] == -1) {
                            Ocean.trackerTemp[row - 1][column + i] = -2;
                        } else {
                            hCheck = false;
                            return false;
                        }
                    }
                }

                if (row + 1 < 10) {
                    for (int i = 0; i < 1; i++) {
                        if (Ocean.trackerTemp[row + 1][column + i] == -1) {
                            Ocean.trackerTemp[row + 1][column + i] = -2;
                        } else {
                            hCheck = false;
                            return false;
                        }
                    }
                }

                if (column - 1 >= 0) {
                    if (Ocean.trackerTemp[row][column - 1] == -1) {
                        Ocean.trackerTemp[row][column - 1] = -2;
                    } else {
                        hCheck = false;
                        return false;
                    }
                }

                if (column + 1 < 10) {
                    if (Ocean.trackerTemp[row][column + 1] == -1) {
                        Ocean.trackerTemp[row][column + 1] = -2;
                    } else {
                        hCheck = false;
                        return false;
                    }
                }

                if (hCheck == false) {
                    return false;
                } else {
                    return true;
                }
            }
        }//end submarine
///////////////////////////////////////////////////////////////////////////////////////////////////////////

        return true;
    }

    public int getLength() {
        return length;
    }

    public void setLength(int length) {
        this.length = length;
        hit = new boolean[this.length];
        for (int i = 0; i < this.length; i++) {
            hit[i] = false;
        }
    }

    public boolean isSunk() {
        for (boolean b : hit) {
            if (b != true) {
                return false;
            }
        }
        return true;
    }

    public boolean isHit() {
        for (boolean b : hit) {
            if (b == true) {
                return true;
            }
        }
        return false;
    }

    public boolean shootAt(int row, int column) {
        boolean ret = false;
        if (horizontal == true) {
            if (row == bowRow) {
                if ((column >= bowColumn) && (column < (bowColumn + length))) {
                    ret = true;
                    //update hit
                    hit[column - bowColumn] = true;
                }
            }
        } else {
            if (column == bowColumn) {
                if ((row >= bowRow) && (row < (bowRow + length))) {
                    ret = true;
                    //update hit
                    hit[row - bowRow] = true;
                }
            }
        }
        return ret;
    }

    void placeShipAt(int row, int column, boolean horizontal, Ocean ocean) {

        if (Ocean.shipTypeTemp.equals("BattleShip")) {
            if (!horizontal) {
                ocean.getShipArray()[row][column] = new BattleShip(row, column, horizontal);
                ocean.getShipArray()[row][column].setBowRow(row);
                ocean.getShipArray()[row][column].setBowColumn(column);
                ocean.getShipArray()[row][column].setLength(4);
                ocean.getShipArray()[row][column].setHorizontal(horizontal);

                ocean.getShipArray()[row + 1][column] = ocean.getShipArray()[row][column];

                ocean.getShipArray()[row + 2][column] = ocean.getShipArray()[row][column];

                ocean.getShipArray()[row + 3][column] = ocean.getShipArray()[row][column];

            } else {
                ocean.getShipArray()[row][column] = new BattleShip(row, column, horizontal);
                ocean.getShipArray()[row][column].setBowRow(row);
                ocean.getShipArray()[row][column].setBowColumn(column);
                ocean.getShipArray()[row][column].setLength(4);
                ocean.getShipArray()[row][column].setHorizontal(horizontal);

                ocean.getShipArray()[row][column + 1] = ocean.getShipArray()[row][column];

                ocean.getShipArray()[row][column + 2] = ocean.getShipArray()[row][column];

                ocean.getShipArray()[row][column + 3] = ocean.getShipArray()[row][column];

            }
        }

        if (Ocean.shipTypeTemp.equals("Cruiser")) {
            if (!horizontal) {
                ocean.getShipArray()[row][column] = new Cruiser(row, column, horizontal);
                ocean.getShipArray()[row][column].setBowRow(row);
                ocean.getShipArray()[row][column].setBowColumn(column);
                ocean.getShipArray()[row][column].setLength(3);
                ocean.getShipArray()[row][column].setHorizontal(horizontal);

                ocean.getShipArray()[row + 1][column] = ocean.getShipArray()[row][column];

                ocean.getShipArray()[row + 2][column] = ocean.getShipArray()[row][column];

            } else {
                ocean.getShipArray()[row][column] = new Cruiser(row, column, horizontal);
                ocean.getShipArray()[row][column].setBowRow(row);
                ocean.getShipArray()[row][column].setBowColumn(column);
                ocean.getShipArray()[row][column].setLength(3);
                ocean.getShipArray()[row][column].setHorizontal(horizontal);

                ocean.getShipArray()[row][column + 1] = ocean.getShipArray()[row][column];

                ocean.getShipArray()[row][column + 2] = ocean.getShipArray()[row][column];

            }
        }

        if (Ocean.shipTypeTemp.equals("Destroyer")) {
            if (!horizontal) {
                ocean.getShipArray()[row][column] = new Destroyer(row, column, horizontal);
                ocean.getShipArray()[row][column].setBowRow(row);
                ocean.getShipArray()[row][column].setBowColumn(column);
                ocean.getShipArray()[row][column].setLength(2);
                ocean.getShipArray()[row][column].setHorizontal(horizontal);

                ocean.getShipArray()[row + 1][column] = ocean.getShipArray()[row][column];

            } else {
                ocean.getShipArray()[row][column] = new Destroyer(row, column, horizontal);
                ocean.getShipArray()[row][column].setBowRow(row);
                ocean.getShipArray()[row][column].setBowColumn(column);
                ocean.getShipArray()[row][column].setLength(2);
                ocean.getShipArray()[row][column].setHorizontal(horizontal);

                ocean.getShipArray()[row][column + 1] = ocean.getShipArray()[row][column];

            }
        }

        if (Ocean.shipTypeTemp.equals("Submarine")) {
            ocean.getShipArray()[row][column] = new Submarine(row, column, horizontal);
            ocean.getShipArray()[row][column].setBowRow(row);
            ocean.getShipArray()[row][column].setBowColumn(column);
            ocean.getShipArray()[row][column].setLength(1);
            ocean.getShipArray()[row][column].setHorizontal(horizontal);
        }

    }

    @Override
    public String toString() {
        String shipCharacter = ".";
        if (this.isSunk()) {
            shipCharacter = "x";
        } else if (this.isHit()) {
            shipCharacter = "S";
        }
        return shipCharacter;
    }

}//end of class ship
